Attribute VB_Name = "SMU"

Public Sub initialize(SMU As Integer)
Call send(SMU, "*cls", intStatus)
Call send(SMU, "*rst", intStatus)
Call send(SMU, "rout:term rear", intStatus)
Call send(SMU, "syst:beep:stat off", intStatus)
Call send(SMU, "syst:azer off", intStatus)
Call send(SMU, "sens:volt:prot 12", intStatus)
Call settimeout(999999)

End Sub

Public Sub SweepTlink(SMU As Integer, intRow As Integer)
Call send(SMU, ":trig:clear", intStatus)
Call send(SMU, ":arm:sour tlink", intStatus)   'set arm source to tlink
Call send(SMU, ":arm:dir acc", intStatus)    'bypass first source event detector
Call send(SMU, ":arm:count " & intRow, intStatus)
Call send(SMU, ":arm:outp trig", intStatus)
Call send(SMU, ":arm:ilin 2", intStatus)
Call send(SMU, ":arm:olin 1", intStatus)
Call send(SMU, ":trig:dir sour", intStatus)
Call send(SMU, ":trig:coun " & intpoints, intStatus)
Call send(SMU, ":trig:sour imm", intStatus)            'use trigger link
Call send(SMU, ":trig:delay 0", intStatus)               'set trigger delay to 0mS

End Sub
Public Function SourceTlink(SMU As Integer, intRow As Integer)
Call send(SMU, ":trig:clear", intStatus)
Call send(SMU, ":arm:sour imm", intStatus)    'set arm source to tlink
Call send(SMU, ":arm:dir acc", intStatus)
Call send(SMU, ":arm:count " & intRow, intStatus)
Call send(SMU, ":trig:dir acc", intStatus)
Call send(SMU, ":trig:sour tlink", intStatus)            'use trigger link
Call send(SMU, ":trig:coun 1", intStatus)
Call send(SMU, ":trig:ilin 2", intStatus)                'input trigger on line 1
Call send(SMU, ":trig:olin 1", intStatus)                'output trigger on line 2
Call send(SMU, ":trig:input sour", intStatus)          'wait for input trigger before measuring
Call send(SMU, ":trig:outp sens", intStatus)              'output trigger after soaking device
Call send(SMU, ":trig:delay 0", intStatus)               'set trigger delay to 0mS
End Function

Private Sub SmuGlobal(SMU As Integer)
Call send(SMU, ":sens:aver:stat off", intStatus)
Call send(SMU, ":syst:azer:stat off", intStatus)

End Sub
Public Sub Source(SMU As Integer, Bias As Single, currange As Single, nplc As String, sdelay As String)
SmuGlobal (SMU)

Call send(SMU, ":sour:volt " & Bias, intStatus)
Call send(SMU, ":sour:del " & sdelay, intStatus)
Call send(SMU, ":sens:func 'curr'", intStatus)
Call send(SMU, ":sens:curr:nplc " & nplc, intStatus)
Call send(SMU, ":sens:curr:rang:auto off", intStatus)
Call send(SMU, ":sens:curr:prot 0.01", intStatus)
Call send(SMU, ":sens:curr:range " & currange, intStatus)


End Sub

Public Sub SweepStart(SMU As Integer, intpoints As Integer)
SmuGlobal (SMU)
Dim poll As Integer

Call send(SMU, "*cls", intStatus)                        'clear all registers
Call send(SMU, ":trace:feed:cont never", intStatus)      'disable trace logic
Call send(SMU, ":trace:cle", intStatus)                'clear trace logic
Call send(SMU, ":trace:poin " & intpoints, intStatus)    'set number of measurments to record
Call send(SMU, ":trace:feed sens", intStatus)            'feed trace memory with measurments
Call send(SMU, ":trace:feed:cont next", intStatus)    'enable trace logic
Call send(SMU, ":outp on", intStatus)    'enable trace logic
Call send(SMU, ":init", intStatus)    'enable trace logic

Do
    DoEvents        'the 2400 will issue an srq once the buffer is full and testing complete
Loop Until (srq And 1)
Call spoll(SMU, poll, intStatus)

End Sub
Public Sub OpenShortTest(SMU As Integer, range As String, nplc As String, sdelay As String)
SmuGlobal (SMU)
Call send(SMU, ":sens:func:off:all", intStatus)
Call send(SMU, ":sens:func 'volt'", intStatus)
Call send(SMU, ":sens:volt:nplc " & nplc, intStatus)
Call send(SMU, ":sour:func curr", intStatus)
Call send(SMU, ":sour:del " & sdelay, intStatus)
Call send(SMU, ":sour:curr:rang:auto off", intStatus)

        
        If range = "2K" Then
        Call send(SMU, ":sour:curr:rang .001" & Bias, intStatus)
        Call send(SMU, ":sour:curr .001" & Bias, intStatus)
        Call send(SMU, ":sens:volt:rang 2", intStatus)
        ResCurrent = 0.001
        End If
        If range = "20K" Then
        Call send(SMU, ":sour:curr:rang .0001" & Bias, intStatus)
        Call send(SMU, ":sour:curr .0001" & Bias, intStatus)
        Call send(SMU, ":sens:volt:rang 2", intStatus)
        ResCurrent = 0.0001
        End If
        If range = "200K" Then
        Call send(SMU, ":sour:curr:rang .00001" & Bias, intStatus)
        Call send(SMU, ":sour:curr .00001" & Bias, intStatus)
        Call send(SMU, ":sens:volt:rang 2", intStatus)
        ResCurrent = 0.00001
        End If
        If range = "2M" Then
        Call send(SMU, ":sour:curr:rang .000001" & Bias, intStatus)
        Call send(SMU, ":sour:curr .000001" & Bias, intStatus)
        Call send(SMU, ":sens:volt:rang 2", intStatus)
        ResCurrent = 0.000001
        End If
        If range = "20M" Then
        Call send(SMU, ":sour:curr:rang .000001" & Bias, intStatus)
        Call send(SMU, ":sour:curr .0000001" & Bias, intStatus)
        Call send(SMU, ":sens:volt:rang 2", intStatus)
        ResCurrent = 0.0000001
        End If
        
        
Call send(SMU, ":syst:rsen off", intStatus)
End Sub
Public Function Sweep(SMU As Integer, strSrc As String, strMea As String, sngProt As Single, nplc As String, sdelay As String, sngStart As Single, sngStep As Single, sngStop As Single, intpoints As Integer) As Single
Points
SmuGlobal (SMU)
Call send(SMU, ":sour:func " & strSrc, intStatus)
Call send(SMU, ":sens:func:off:all", intStatus)
Call send(SMU, ":sens:func '" & strMea & ":dc'", intStatus)
Call send(SMU, ":sens:curr:prot " & sngProt, intStatus)
Call send(SMU, ":sens:curr:nplc " & nplc, intStatus)
Call send(SMU, ":sens:curr:rang:auto on ", intStatus)
Call send(SMU, ":sour:volt:start " & sngStart, intStatus)
Call send(SMU, ":sour:volt:stop " & sngStop, intStatus)
Call send(SMU, ":sour:volt:step " & sngStep, intStatus)
Call send(SMU, ":sour:volt:mode swe", intStatus)
Call send(SMU, ":sour:swe:rang best", intStatus)
Call send(SMU, ":sour:swe:spac lin", intStatus)
Call send(SMU, ":stat:meas:enab 512", intStatus)         'mask "buffer full" byte
Call send(SMU, "*sre 1", intStatus)                      'mask "measurement summary bit" for SRQ
Call send(SMU, ":trig:coun " & intpoints, intStatus)
Call send(SMU, ":sour:del " & sdelay, intStatus)
End Function
Public Sub Points()
dblStart = CDbl(frmIV.txtStart)
dblStop = CDbl(frmIV.txtStop)
dblStep = CDbl(frmIV.txtStep)
intpoints = CInt(frmIV.txtPoints)
frmIV.txtPoints.Text = (dblStop - dblStart) / dblStep + 1
End Sub
Public Function CalPoints(sngStart As Single, sngStep As Single, sngStop As Single) As Integer
CalPoints = (sngStop - sngStart) / sngStep + 1
End Function
Public Sub BufferSetting(SMU As Integer, Elem As String)
Call send(SMU, ":form:elem " + Elem, intStatus)
Call send(SMU, ":form:data sre;bord swap", intStatus)
End Sub
Public Sub MeasureFourLeak(x As Integer)
Dim byteArray!(1 To 1000)
Dim intColumnPos As Integer
Dim m As Integer

intColumnPos = (x - 1) * 4

            Call send(SMU1, "outp on;:init", intStatus)
            Call send(SMU2, "outp on;:init", intStatus)
            Call send(SMU3, "outp on;:init", intStatus)
            Call send(SMU4, "outp on;:init", intStatus)
            
        Call send(K7002, ":init", intStatus)
        
       
                   
            Call send(SMU1, ":fetch?", intStatus)
                Call transmit("UNT UNL MLA TALK" + Str$(SMU1), intStatus)
                Call IErarray(byteArray!(1), 2, lLength, lStatus)
                Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                    For m = 1 To intRow
                        LeakDataBuff(m, intColumnPos + 1) = byteArray!(m) - OffsetSMU1
                        frmGridGraph.MSFlexGrid.TextMatrix(m, intColumnPos + 1) = Format(LeakDataBuff(m, intColumnPos + 1), "0.00E+")
                        DoEvents
                    Next m
                Call transmit("UNT UNL", intStatus)
                Call send(SMU1, ":outp:stat off", intStatus)
         
                        
            Call send(SMU2, ":fetch?", intStatus)
                Call transmit("UNT UNL MLA TALK" + Str$(SMU2), intStatus)
                    Call IErarray(byteArray!(1), 2, lLength, lStatus)
                    Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                        For m = 1 To intRow
                            LeakDataBuff(m, intColumnPos + 2) = byteArray!(m) - OffsetSMU2
                            frmGridGraph.MSFlexGrid.TextMatrix(m, intColumnPos + 2) = Format(LeakDataBuff(m, intColumnPos + 2), "0.00E+")
                            DoEvents
                        Next m
                Call transmit("UNT UNL", intStatus)
                Call send(SMU2, ":outp:stat off", intStatus)
                    
         
            
            Call send(SMU3, ":fetch?", intStatus)
                Call transmit("UNT UNL MLA TALK" + Str$(SMU3), intStatus)
                    Call IErarray(byteArray!(1), 2, lLength, lStatus)
                    Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                        For m = 1 To intRow
                            LeakDataBuff(m, intColumnPos + 3) = byteArray!(m) - OffsetSMU3
                            frmGridGraph.MSFlexGrid.TextMatrix(m, intColumnPos + 3) = Format(LeakDataBuff(m, intColumnPos + 3), "0.00E+")
                            DoEvents
                        Next m
                Call transmit("UNT UNL", intStatus)
                Call send(SMU3, ":outp:stat off", intStatus)
        
        
                
                Call send(SMU4, ":fetch?", intStatus)
                Call transmit("UNT UNL MLA TALK" + Str$(SMU4), intStatus)
                    Call IErarray(byteArray!(1), 2, lLength, lStatus)
                    Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                        For m = 1 To intRow
                            LeakDataBuff(m, intColumnPos + 4) = byteArray!(m) - OffsetSMU4
                            frmGridGraph.MSFlexGrid.TextMatrix(m, intColumnPos + 4) = Format(LeakDataBuff(m, intColumnPos + 4), "0.00E+")
                            DoEvents
                        Next m
                Call transmit("UNT UNL", intStatus)
                Call send(SMU4, ":outp:stat off", intStatus)
            
      
        Call send(K7002, ":open all", intStatus)
        DoEvents

End Sub
Public Sub MeasureFourOS(x As Integer)
Dim byteArray!(1 To 1000)
Dim intColumnPos As Integer
Dim i As Integer

intColumnPos = (x - 1) * 4

         Call send(SMU1, "outp on;:init", intStatus)
         Call send(SMU2, "outp on;:init", intStatus)
         Call send(SMU3, "outp on;:init", intStatus)
         Call send(SMU4, "outp on;:init", intStatus)

         
         Call send(K7002, ":init", intStatus)
                 
             Call send(SMU1, ":fetch?", intStatus)
             Call transmit("UNT UNL MLA TALK" + Str$(SMU1), intStatus)
             Call IErarray(byteArray!(1), 2, lLength, lStatus)
             Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                For i = 1 To intRow
                    OpenShortBuff(i, intColumnPos + 1) = Abs(byteArray!(i)) / ResCurrent
                    frmGridGraph.MSFlexGrid.TextMatrix(i, intColumnPos + 1) = Format(OpenShortBuff(i, intColumnPos + 1), "0.00E+")
                    DoEvents
                Next i
             Call transmit("UNT UNL", intStatus)
             Call send(SMU1, ":outp:stat off", intStatus)
             
             Call send(SMU2, ":fetch?", intStatus)
             Call transmit("UNT UNL MLA TALK" + Str$(SMU2), intStatus)
             Call IErarray(byteArray!(1), 2, lLength, lStatus)
             Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                For i = 1 To intRow
                    OpenShortBuff(i, intColumnPos + 2) = Abs(byteArray!(i)) / ResCurrent
                    frmGridGraph.MSFlexGrid.TextMatrix(i, intColumnPos + 2) = Format(OpenShortBuff(i, intColumnPos + 2), "0.00E+")
                    DoEvents
                Next i
             Call transmit("UNT UNL", intStatus)
             Call send(SMU2, ":outp:stat off", intStatus)
             
             Call send(SMU3, ":fetch?", intStatus)
             Call transmit("UNT UNL MLA TALK" + Str$(SMU3), intStatus)
             Call IErarray(byteArray!(1), 2, lLength, lStatus)
             Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                For i = 1 To intRow
                    OpenShortBuff(i, intColumnPos + 3) = Abs(byteArray!(i)) / ResCurrent
                    frmGridGraph.MSFlexGrid.TextMatrix(i, intColumnPos + 3) = Format(OpenShortBuff(i, intColumnPos + 3), "0.00E+")
                    DoEvents
                Next i
             Call transmit("UNT UNL", intStatus)
             Call send(SMU3, ":outp:stat off", intStatus)
             
             Call send(SMU4, ":fetch?", intStatus)
             Call transmit("UNT UNL MLA TALK" + Str$(SMU4), intStatus)
             Call IErarray(byteArray!(1), 2, lLength, lStatus)
             Call IErarray(byteArray!(1), (intRow * 4) + 1, lLength, lStatus)
                For i = 1 To intRow
                    OpenShortBuff(i, intColumnPos + 4) = Abs(byteArray!(i)) / ResCurrent
                    frmGridGraph.MSFlexGrid.TextMatrix(i, intColumnPos + 4) = Format(OpenShortBuff(i, intColumnPos + 4), "0.00E+")
                    DoEvents
                Next i
             Call transmit("UNT UNL", intStatus)
             Call send(SMU4, ":outp:stat off", intStatus)

    
            Call send(K7002, ":open all", intStatus)
            
DoEvents

End Sub

Public Sub SinglePointGetBuff(intAdr As Integer, intpoints As Integer)
Dim sngTemp(1 To 2) As Single
Dim byteArray!(1 To 1000)


Call transmit("UNT UNL MLA TALK" + Str$(intAdr), intStatus)

Call IErarray(byteArray!(1), 2, lLength, lStatus)

Call IErarray(byteArray!(1), (intpoints * 4) + 1, lLength, lStatus)

    If reverse = 1 Then
        For i = 1 To intpoints
            sngSinglePointBuff(1, i) = frmIV.sngStart + (i - 1) * frmIV.sngStep
            sngSinglePointBuff(2, i) = byteArray!(i)
        Next i
    Else
        For i = 1 To intpoints
            sngSinglePointBuff(1, i) = frmIV.sngStart + (i - 1) * frmIV.sngStep
            sngSinglePointBuff(2, i) = byteArray!(i)
        Next i
    End If

Call transmit("UNT UNL", intStatus)
End Sub

